#include <syslog.h>
#include <stdarg.h>
#include <stdio.h>

extern int LogToStdout;

void olog(char *ident, int option, int facility)
{
  if (!LogToStdout)
  {
    openlog(ident, option, facility);
  }
}

void slog(int priority, char *format, ...)
{
  char buf[1024];
  va_list ap;

  if (LogToStdout)
  {
    switch(priority)
    {
      case LOG_EMERG:
        strcpy(buf,"emergency: ");
        break;
      case LOG_ALERT:
        strcpy(buf,"alert: ");
        break;
      case LOG_CRIT:
        strcpy(buf,"critical: ");
        break;
      case LOG_ERR:
        strcpy(buf,"error: ");
        break;
      case LOG_WARNING:
        strcpy(buf,"warning: ");
        break;
      case LOG_NOTICE:
        strcpy(buf,"notice: ");
        break;
      case LOG_INFO:
        strcpy(buf,"info: ");
        break;
      case LOG_DEBUG:
        strcpy(buf,"debug: ");
        break;
    }
  }
  else
  {
    buf[0]='\0';
  }

  va_start(ap, format);
  vsnprintf(buf,1024-strlen(buf), format, ap);
  buf[1023]='\0';
  va_end(ap);

  if (LogToStdout)
  {
    puts(buf);
    fflush(stdout);
  }
  else
  {
    syslog(priority, "%s", buf);
  }
}
